unit Defs;

interface

uses WinTypes, WinProcs;


const
  cm_DrawingRButtonDown =  10;
  cm_DrawingLButtonDown =  11;
  cm_DrawingMouseMove   =  12;
  cm_DrawingLButtonUp   =  13;

  cm_MyWindowChar       =  14;

  cm_SaveBitmap         =  20;
  cm_ClearBitmap        =  21;
  cm_SetScrollBars      =  22;

  cm_SetMenu            =  30;

  ad_Left      =  1;
  ad_Top       =  2;
  ad_Right     =  4;
  ad_Bottom    =  8;

type
  PIterateInfo = ^TIterateInfo;
  TIterateInfo = record
    Anz: Integer;
    SelfIterate: Boolean;
  end;

  PBlendInfo = ^TBlendInfo;
  TBlendInfo = record
    Steps: Integer;
  end;

  PRotateInfo = ^TRotateInfo;
  TRotateInfo = record
    Alpha: Real;
  end;

  PSizeInfo = ^TSizeInfo;
  TSizeInfo = record
    X1, Y1, X2, Y2: Real;
  end;

  PGridInfo = ^TGridInfo;
  TGridInfo = record
    GridX, GridY: Real;
    SnapX, SnapY, Show: Boolean;
  end;

  PMoveInfo = ^TMoveInfo;
  TMoveInfo = record
    X1, Y1, X2, Y2: Real;
  end;

  PFilename = ^TFilename;
  TFilename = array[0..255] of Char;



var
    Colr: array[0..255] of longint;
    CurrentFillColor,
    CurrentColor: Integer;

    TheRedPen,
    TheBkPen: HPen;
    TheBkBrush: HBrush;

    ToolsActive,
    ToolsBusy: Boolean;

    CaretVis: Boolean;

    xw, yw: Integer;
    TWActive,
    TPActive: Boolean;
    TP1, TP2, OldTP1,
    TW1, TW2, OldTW1: TPoint;

    BufferBitmap: HBitmap;
    BufferDC,
    vhDC: HDC;


implementation

procedure InitColors;
 var
    i: Integer;
begin
  for i := 0 to 255 do
    Colr[i] := -1;

  Colr[ 0] := rgb(  0,  0,  0);
  Colr[ 1] := rgb(255,255,255);
  Colr[ 2] := rgb(255,  0,  0);
  Colr[ 3] := rgb(  0,255,  0);
  Colr[ 4] := rgb(  0,  0,255);
  Colr[ 5] := rgb(255,255,  0);
  Colr[ 6] := rgb(255,  0,255);
  Colr[ 7] := rgb(  0,255,255);
  Colr[ 8] := rgb(127,127,127);
  Colr[ 9] := rgb(127,  0,  0);
  Colr[10] := rgb(  0,127,  0);
  Colr[11] := rgb(  0,  0,127);
  Colr[12] := rgb(127,127,  0);
  Colr[13] := rgb(127,  0,127);
  Colr[14] := rgb(  0,127,127);

  for i := 0 to 15 do
  begin
    Colr[1*16+i] := rgb(255-16*i, 0, 0);
    Colr[2*16+i] := rgb(0, 255-16*i, 0);
    Colr[3*16+i] := rgb(0, 0, 255-16*i);
  end;
  CurrentColor := 0;
  CurrentFillColor := 2;
end;

{ Deal with deinitialization of unit. }
var
  SaveExit: Pointer;

procedure DefsExit;
far;
begin
  ExitProc := SaveExit;

  DeleteObject(TheRedPen);
{  DeleteObject(TheBkPen);
  DeleteObject(TheBkBrush);
}
end;

{ initialization }
begin
  TheRedPen  := CreatePen(ps_solid,1,rgb(255,0,0));
  TheBkPen   := GetStockObject(White_Pen);
  TheBKBrush := GetStockObject(White_Brush);
{  TheBkPen  := CreatePen(ps_solid,1,GetSysColor(color_Window));
  TheBKBrush := CreateSolidBrush(GetSysColor(color_Window));
}
  vhDC := 0;
  BufferDC := 0;
  BufferBitmap := 0;

  InitColors;

  SaveExit := ExitProc;
  ExitProc := @DefsExit;
end.

end.