Program AI2CDR;

{ $N+}

{$R AI2CDR.RES}

Uses {WObjects}Objects, WinTypes, WinProcs, {StdDlgs,} Strings, BWCC,
     Win31, Bezier2, Bezier1, BezDefs, Tools, MyToolBar,
     Drawing, Status, Defs, Dialogs, ToolWindow, GrTools,
     Script, Fonts, OWindows;

CONST
  APPNAME = 'AI2CDR';

  cm_Open         = 101;
  cm_Conv         = 102;
  cm_SaveAreas    = 103;
  cm_SaveLines    = 104;

  cm_Quit         = 105;

  cm_Cut          = 201;
  cm_Copy         = 202;   
  cm_Paste        = 203;
  cm_Clear        = 204;

  cm_SelectAll    = 205;

  cm_FillPalette  = 206;
  cm_ChooseFont   = 207;
  cm_SetSize      = 208;
  cm_SetGrid      = 209;

  cm_Group        = 301;
  cm_UnGroup      = 302;
  cm_Connect      = 303;

  cm_Back         = 304;
  cm_Front        = 305;
  cm_OneForward   = 306;
  cm_OneBack      = 307;

  cm_ShowMenu     = 308;
  cm_ShowPal      = 309;

  cm_Skip_Cut       = 401;
  cm_Skip_Line      = 402;
  cm_Skip_All       = 403;

  cm_ShowProgress = 404;

  cm_ScriptRecord   = 405;
  cm_ScriptPlay     = 406;
  cm_ScriptIterate  = 407;
  cm_ScriptClear    = 408;

  cm_Blend        = 409;

  cm_Break        = 410;





TYPE
  TMyApplication = Object(TApplication)
    Procedure InitMainWindow; Virtual;
  END;

  PMyWindow = ^TMyWindow;
  TMyWindow = Object(TWindow)
    ToolWindow: PToolWindow;
    PaletteWindow: PPaletteWindow;
    ToolBar: PToolBar;
    StateLine: PStateLine;
    Drawing: PDrawing;
    ShowColor: PShowColor;
    Running,
    BreakFlag,
    Converted: Boolean;
    InFileName: String;
    Accel: THandle;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure SetupWindow; virtual;
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure UpdateChildren; virtual;

    Procedure cmOpen(VAR MSG: TMessage); virtual cm_First + cm_Open;
    Procedure cmConv(VAR MSG: TMessage); virtual cm_First + cm_Conv;
    Procedure cmSaveAreas(VAR MSG: TMessage); virtual cm_First + cm_SaveAreas;
    Procedure cmSaveLines(VAR MSG: TMessage); virtual cm_First + cm_SaveLines;
    Procedure cmQuit(VAR MSG: TMessage); virtual cm_First + cm_Quit;
    Procedure cmCut(VAR MSG: TMessage); virtual cm_First + cm_Cut;
    Procedure cmCopy(VAR MSG: TMessage); virtual cm_First + cm_Copy;
    Procedure cmPaste(VAR MSG: TMessage); virtual cm_First + cm_Paste;
    Procedure cmClear(VAR MSG: TMessage); virtual cm_First + cm_Clear;
    Procedure cmSelectAll(VAR MSG: TMessage); virtual cm_First + cm_SelectAll;
    Procedure cmFillPalette(VAR MSG: TMessage); virtual cm_First + cm_FillPalette;
    Procedure cmChooseFont(VAR MSG: TMessage); virtual cm_First + cm_ChooseFont;
    Procedure cmSetSize(VAR MSG: TMessage); virtual cm_First + cm_SetSize;
    Procedure cmSetGrid(VAR MSG: TMessage); virtual cm_First + cm_SetGrid;
    Procedure cmGroup(VAR MSG: TMessage); virtual cm_First + cm_Group;
    Procedure cmUngroup(VAR MSG: TMessage); virtual cm_First + cm_Ungroup;
    Procedure cmConnect(VAR MSG: TMessage); virtual cm_First + cm_Connect;
    Procedure SetSelPos(Pos: Word); virtual;
    Procedure cmBack(VAR MSG: TMessage); virtual cm_First + cm_Back;
    Procedure cmFront(VAR MSG: TMessage); virtual cm_First + cm_Front;
    Procedure cmOneBack(VAR MSG: TMessage); virtual cm_First + cm_OneBack;
    Procedure cmOneForward(VAR MSG: TMessage); virtual cm_First + cm_OneForward;
    Procedure cmShowMenu(VAR MSG: TMessage); virtual cm_First + cm_ShowMenu;
    Procedure cmShowPal(VAR MSG: TMessage); virtual cm_First + cm_ShowPal;
    Procedure cmSkipCut(VAR MSG: TMessage); virtual cm_First + cm_Skip_Cut;
    Procedure cmSkipLine(VAR MSG: TMessage); virtual cm_First + cm_Skip_Line;
    Procedure cmSkipAll(VAR MSG: TMessage); virtual cm_First + cm_Skip_all;
    Procedure cmScriptRecord(VAR MSG: TMessage); virtual cm_First + cm_ScriptRecord;
    Procedure cmScriptPlay(VAR MSG: TMessage); virtual cm_First + cm_ScriptPlay;
    Procedure cmScriptIterate(VAR MSG: TMessage); virtual cm_First + cm_ScriptIterate;
    Procedure cmScriptClear(VAR MSG: TMessage); virtual cm_First + cm_ScriptClear;
    Procedure cmBlend(VAR MSG: TMessage); virtual cm_First + cm_Blend;
    Procedure cmBreak(VAR MSG: TMessage); virtual cm_First + cm_Break;
    Procedure cmShowProgress(VAR MSG: TMessage); virtual cm_First + cm_ShowProgress;

    Procedure cmSetMenu(VAR MSG: TMessage); virtual cm_First + cm_SetMenu;

{    procedure WMGetMinMaxInfo(var Msg: TMessage); virtual wm_First+wm_GetMinMaxInfo;}
    procedure WMSize(var Msg: TMessage); virtual wm_First + wm_Size;
    procedure WMMove(var Msg: TMessage); virtual wm_First + wm_Move;
    procedure WMTimer(var Msg: TMessage); virtual wm_First + wm_Timer;
    Procedure WMChar(VAR MSG: TMessage); virtual wm_First + wm_Char;

    Function  CanClose: Boolean; Virtual;
  END;


{---------------------  Konfiguration -------------------}


procedure LoadConfig;
 var
    p,IniFile: array[0..255] of Char;
begin
  GetWindowsDirectory(IniFile,255);
  StrCat(IniFile,'\PASCAL.INI');
  GetPrivateProfileString(APPNAME,'AI-DIR','C:\',p,255,IniFile);
  AIDIR := StrPas(p);
  GetPrivateProfileString(APPNAME,'CDR-DIR','C:\',p,255,IniFile);
  CDRDIR := StrPas(p);
end;


procedure SaveConfig;
 var
    p,IniFile: array[0..200] of Char;
begin
  GetWindowsDirectory(IniFile,240);
  StrCat(IniFile,'\PASCAL.INI');
  StrPCopy(p,AIDIR);
  WritePrivateProfileString(APPNAME,'AI-DIR',p,IniFile);
  StrPCopy(p,CDRDIR);
  WritePrivateProfileString(APPNAME,'CDR-DIR',p,IniFile);
end;



{---------------------  Oberflche ----------------------}



Constructor TMyWindow.Init(AParent: PWindowsObject; ATitle: PChar);
 var
    r: TRect;
    MSG: TMessage;
BEGIN
  TWindow.Init(AParent, ATitle);
  xw := 320;
  yw := 240;
  Attr.X    := 100;
  Attr.Y    := 100;
  Attr.W    := 2+ xw +17+6;
  Attr.H    := 40+ yw +20+32+20 +17+6;
  Attr.Menu := LoadMenu(HInstance, 'MENU_1');

{  Attr.Style := (Attr.Style and not ws_ThickFrame);}

  Running   := False;
  InFileName := '';
  Converted := False;

  LoadConfig;

  StateLine := new(PStateLine, Init(@Self));
  ShowColor := New(PShowColor, Init(@Self));
  Drawing := New(PDrawing, Init(@Self));
  ToolBar := New(PToolBar, Init(@Self,Drawing,StateLine));
  TWActive := False;
  TPActive := False;


  CheckMenuItem(Attr.Menu, cm_ShowProgress, mf_Checked or mf_ByCommand);
  CMSetMenu(MSG);


END;


procedure TMyWindow.CMSetMenu(VAR MSG: TMessage);
begin
  if World.Count>0 then
  begin
    EnableMenuItem(Attr.Menu, cm_Cut, mf_Enabled or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Copy, mf_Enabled or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Clear, mf_Enabled or mf_ByCommand);
  end
  else
  begin
    EnableMenuItem(Attr.Menu, cm_Cut, mf_Grayed or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Copy, mf_Grayed or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Clear, mf_Grayed or mf_ByCommand);
  end;

  if World.Copy.Count>0 then
    EnableMenuItem(Attr.Menu, cm_Paste, mf_Enabled or mf_ByCommand)
  else
    EnableMenuItem(Attr.Menu, cm_Paste, mf_Grayed or mf_ByCommand);

  if World.Count+World.Pool.Count>0 then
  begin
    EnableMenuItem(Attr.Menu, cm_Conv, mf_Enabled or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_SaveLines, mf_Enabled or mf_ByCommand);
  end
  else
  begin
    EnableMenuItem(Attr.Menu, cm_Conv, mf_Grayed or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_SaveLines, mf_Grayed or mf_ByCommand);
  end;

  if PASNEWNAME<>'' then
    EnableMenuItem(Attr.Menu, cm_SaveAreas, mf_Enabled or mf_ByCommand)
  else
    EnableMenuItem(Attr.Menu, cm_SaveAreas, mf_Grayed or mf_ByCommand);

  if World.Pool.Count>0 then
    EnableMenuItem(Attr.Menu, cm_SelectAll, mf_Enabled or mf_ByCommand)
  else
    EnableMenuItem(Attr.Menu, cm_SelectAll, mf_Grayed or mf_ByCommand);

  if (CurrentColor<>CurrentFillColor) and TPActive then
    EnableMenuItem(Attr.Menu, cm_FillPalette, mf_Enabled or mf_ByCommand)
  else
    EnableMenuItem(Attr.Menu, cm_FillPalette, mf_Grayed or mf_ByCommand);


  if World.Count>1 then
  begin
    EnableMenuItem(Attr.Menu, cm_Group, mf_Enabled or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Connect, mf_Enabled or mf_ByCommand);
  end
  else
  begin
    EnableMenuItem(Attr.Menu, cm_Group, mf_Grayed or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Connect, mf_Grayed or mf_ByCommand);
  end;

  if (World.Count=1) and
     ((World.GetObject(0)^.GetType and gt_GroupClass) = gt_GroupClass) then
    EnableMenuItem(Attr.Menu, cm_Ungroup, mf_Enabled or mf_ByCommand)
  else
    EnableMenuItem(Attr.Menu, cm_Ungroup, mf_Grayed or mf_ByCommand);

  if TWActive then
    CheckMenuItem(Attr.Menu, cm_ShowMenu, mf_Checked or mf_ByCommand)
  else
    CheckMenuItem(Attr.Menu, cm_ShowMenu, mf_Unchecked or mf_ByCommand);

  if TPActive then
    CheckMenuItem(Attr.Menu, cm_ShowPal, mf_Checked or mf_ByCommand)
  else
    CheckMenuItem(Attr.Menu, cm_ShowPal, mf_Unchecked or mf_ByCommand);

  if Running then
  begin
    EnableMenuItem(Attr.Menu, cm_Skip_Cut, mf_Enabled or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Skip_Line, mf_Enabled or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Skip_all, mf_Enabled or mf_ByCommand);
  end
  else
  begin
    EnableMenuItem(Attr.Menu, cm_Skip_Cut, mf_Grayed or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Skip_Line, mf_Grayed or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_Skip_all, mf_Grayed or mf_ByCommand);
  end;

  if ScriptPlay then
  begin
    CheckMenuItem(Attr.Menu, cm_ScriptPlay, mf_Checked or mf_ByCommand);
    CheckMenuItem(Attr.Menu, cm_ScriptIterate, mf_Checked or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_ScriptRecord, mf_Grayed or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_ScriptClear, mf_Grayed or mf_ByCommand);
  end
  else
  begin
    CheckMenuItem(Attr.Menu, cm_ScriptPlay, mf_Unchecked or mf_ByCommand);
    CheckMenuItem(Attr.Menu, cm_ScriptIterate, mf_Unchecked or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_ScriptRecord, mf_Enabled or mf_ByCommand);
    EnableMenuItem(Attr.Menu, cm_ScriptClear, mf_Enabled or mf_ByCommand);
  end;

  if Running or ScriptPlay then
    EnableMenuItem(Attr.Menu, cm_Break, mf_Enabled or mf_ByCommand)
  else
    EnableMenuItem(Attr.Menu, cm_Break, mf_Grayed or mf_ByCommand);

  if ScriptRecord then
    CheckMenuItem(Attr.Menu, cm_ScriptRecord, mf_Checked or mf_ByCommand)
  else
    CheckMenuItem(Attr.Menu, cm_ScriptRecord, mf_Unchecked or mf_ByCommand);


  if (World.Count=2) then
    EnableMenuItem(Attr.Menu, cm_Blend, mf_Enabled or mf_ByCommand)
  else
    EnableMenuItem(Attr.Menu, cm_Blend, mf_Grayed or mf_ByCommand);
end;

procedure TMyWindow.GetWindowClass(var AWndClass: TWndClass);
begin
  TWindow.GetWindowClass(AWndClass);
  AWndClass.HIcon := LoadIcon(HInstance, 'ProgramIcon');
end;


procedure TMyWindow.SetupWindow;
var
  Result, S: Integer;
  r: TRect;
begin
  TWindow.SetupWindow;
  Result := IDRetry;

  while (SetTimer(hWIndow, 0, 1000, nil) = 0) and (Result = IDRetry) do
    Result := MessageBox(GetFocus,'Statuszeile (Timer) konnte nicht initialisiert werden.', 'AI -> CDR',
      mb_RetryCancel);
  if Result = IDCancel then PostQuitMessage(0);

  MoveWindow(StateLine^.HWindow, 0, yw+31+17, xw+17, 20, True);
  MoveWindow(ShowColor^.HWindow, xw-9, 5, 20, 20, True);
  MoveWindow(ToolBar^.HWindow, 0, 0, (Ord(MaxTool) + 1) * 31 + 1,
    32, True);
  MoveWindow(Drawing^.HWindow, 0, 32, xw+17, yw+17, True);

  Drawing^.InitDCs;

  ToolBar^.InitTools;
  Drawing^.InitMsgWindow(ToolBar^.HWindow);

  UnitInit(Drawing^.HWindow);

  Drawing^.Activate;

  Font.Init;

end;

procedure TMyWindow.UpdateChildren;
begin
  MoveWindow(StateLine^.HWindow, 0, yw+31+17, xw+17, 20, True);
  MoveWindow(ShowColor^.HWindow, xw-9, 5, 20, 20, True);
  MoveWindow(ToolBar^.HWindow, -1, -1, (Ord(MaxTool) + 1) * 31 + 1,
    32, True);
  MoveWindow(Drawing^.HWindow, 0, 31, xw+17, yw+17, True);
end;

procedure TMyWindow.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
 var
    r: TRect;
begin
    UpdateChildren;
    SetRect(r, (Ord(MaxTool) + 1) * 31 , 0, xw+17, 30);
    FillRect(PaintDC, r, GetStockObject (LTGRAY_BRUSH));
    MoveTo(PaintDC,0,30);
    LineTo(PaintDC,xw+17,30);
end;

Procedure TMyWindow.cmOpen(VAR MSG: TMessage);
 var
    s: String;
    MyMsg: TMsg;
    r: TRect;
    TestFile: Text;
BEGIN

  if Running or ToolsActive then
  begin
      BreakFlag := True;
      BreakMain;
      PostMessage(HWindow,wm_command, cm_Open, 0);
      exit;
  end;

  s := AIDIR+'*.AI';
  if NewFileDialog(HWindow,s, False) then
  begin

    assign(TestFile, s);
    {$I-}
    reset(TestFile);
    {$I+}
    if IOResult=0 then
      close(TestFile)
    else
    begin
      MessageBox(HWindow, 'Datei konnte nicht gefunden werden.','AI -> CDR', mb_ok+mb_iconStop);
      exit;
    end;

    InFileName := s;
    AIDIR := InFileName;
    while (AIDIR<>'') and (AIDIR[length(AIDIR)]<>'\') do
      AIDIR := copy(AIDIR,1,length(AIDIR)-1);

    if (not running) and not ToolsActive then
    begin
      BreakFlag := False;
      Running := True;

      CMSetMenu(MSG);

      ResetClip;

      showAI(InFileName);

      WMTimer(MSG);

      SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);

      Drawing^.Activate;

      Running := False;

      CMSetMenu(MSG);
    end;
  end;
END;

Procedure TMyWindow.cmSaveAreas(VAR MSG: TMessage);
 var
    OutFileName: String;
    OutFile: Text;
    MyMsg: TMsg;
    OldCur: HCursor;
BEGIN
  if not Converted or Running then
  begin
      MessageBox(HWindow, 'Es mu erst ein Bild konvertiert werden', 'AI -> CDR', mb_OK+mb_iconStop);
      exit;
  end;

  BreakFlag := False;

  OutFileName := CDRDIR+'*.AI';
  if NewFileDialog(HWindow,OutFileName,True) then
  begin
    Drawing^.Deactivate;

    SetCapture(HWindow);
    OldCur := SetCursor(LoadCursor(0, idc_Wait));

    SaveAreas(OutFileName);
    Converted := False;
    CDRDIR := OutFileName;
    while (CDRDIR<>'') and (CDRDIR[length(CDRDIR)]<>'\') do
      CDRDIR := copy(CDRDIR,1,length(CDRDIR)-1);

    SetCursor(OldCur);
    ReleaseCapture;
    Drawing^.Activate;
    CMSetMenu(MSG);
  end;
END;


Procedure TMyWindow.cmSaveLines(VAR MSG: TMessage);
 var
    s, OutFileName: String;
    InFile, OutFile: Text;
    MyMsg: TMsg;
    OldCur: HCursor;
BEGIN
  if Running or ToolsActive then
  begin
      BreakFlag := True;
      BreakMain;
      PostMessage(HWindow,wm_command, cm_SaveLines, 0);
      exit;
  end;

  BreakFlag := False;

  OutFileName := CDRDIR+'*.AI';
  if NewFileDialog(HWindow, OutFileName, True) then
  begin
    Drawing^.Deactivate;

    SetCapture(HWindow);
    OldCur := SetCursor(LoadCursor(0, idc_Wait));

    SaveLines(OutFileName);

    CDRDIR := OutFileName;
    while (CDRDIR<>'') and (CDRDIR[length(CDRDIR)]<>'\') do
      CDRDIR := copy(CDRDIR,1,length(CDRDIR)-1);

    SetCursor(OldCur);
    ReleaseCapture;
    Drawing^.Activate;
    CMSetMenu(MSG);
  end;
END;

Procedure TMyWindow.cmQuit(VAR MSG: TMessage);
BEGIN
  CloseWindow;
END;

Procedure TMyWindow.cmCut(VAR MSG: TMessage);
BEGIN
  World.ShowFrame;
  World.CopySelected;
  World.DeleteSelected;
  World.ShowFrame;
  CMSetMenu(MSG);
  SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);
END;

Procedure TMyWindow.cmCopy(VAR MSG: TMessage);
BEGIN
  World.CopySelected;
  CMSetMenu(MSG);
END;

Procedure TMyWindow.cmPaste(VAR MSG: TMessage);
BEGIN
  World.ShowFrame;
  World.PasteSelected;
  World.ShowFrame;
  SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);
  CMSetMenu(MSG);
END;

Procedure TMyWindow.cmClear(VAR MSG: TMessage);
BEGIN
  World.ShowFrame;
  World.DeleteSelected;
  World.ShowFrame;
  SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);
  CMSetMenu(MSG);
END;

Procedure TMyWindow.cmSelectAll(VAR MSG: TMessage);
BEGIN
  World.ShowFrame;
  World.SelectAll;
  World.CalcFrame;
  World.ShowFrame;
  SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);
  CMSetMenu(MSG);
END;

Procedure TMyWindow.cmFillPalette(VAR MSG: TMessage);
 var
    c1, c2, i: Integer;
    d, r1, g1, b1, r2, g2, b2: Real;
BEGIN
  if (CurrentColor<>CurrentFillColor) and TPActive then
  begin
    c1 := IMin(CurrentColor, CurrentFillColor);
    c2 := IMax(CurrentColor, CurrentFillColor);
    if Colr[c1]=-1 then
      Colr[c1]:=rgb(255,255,255);
    if Colr[c2]=-1 then
      Colr[c2]:=rgb(255,255,255);
    d := c2-c1;
    b1 := (Colr[c1] shr 16) and $FF;
    g1 := (Colr[c1] shr  8) and $FF;
    r1 := Colr[c1] and $FF;
    b2 := (Colr[c2] shr 16) and $FF;
    g2 := (Colr[c2] shr  8) and $FF;
    r2 := Colr[c2] and $FF;
    for i := 0 to trunc(d) do
      Colr[c1+i] := rgb(trunc(r1+(r2-r1)*i/d),
                        trunc(g1+(g2-g1)*i/d),
                        trunc(b1+(b2-b1)*i/d));
    InvalidateRect(ShowColor^.HWindow, nil, True);
    InvalidateRect(PaletteWindow^.HWindow, nil, True);
  end;
END;

Procedure TMyWindow.cmChooseFont(VAR MSG: TMessage);
 var
    P: TPoint;
BEGIN
  if CaretVis then
  begin
    GetCaretPos(P);
    HideCaret(Drawing^.HWindow);
  end;
  Font.SelectFont;
  if CaretVis then
  begin
    DestroyCaret;
    CreateCaret(Drawing^.HWindow, 0, 2, zy(Font.GetHeight)-zy(0));
    SetCaretPos(P.X,P.Y);
    ShowCaret(Drawing^.HWindow);
  end;
END;

Procedure TMyWindow.cmSetSize(VAR MSG: TMessage);
 var
    Buffer: TSizeInfo;
BEGIN
  GetSize(@Buffer);
  if Application^.ExecDialog(new(PSizeDialog, Init(@Self, @Buffer)))= id_ok then
  begin
    SetSize(@Buffer);
    SendMessage(ToolBar^.HWindow,wm_Command, cm_DrawingRButtonDown, 0);
  end;
END;

Procedure TMyWindow.cmSetGrid(VAR MSG: TMessage);
BEGIN
  if GridInfo.Show then
    HideGrid;
  Application^.ExecDialog(new(PGridDialog, Init(@Self, @GridInfo)));
  if GridInfo.Show then
    ShowGrid;
  SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);
END;

Procedure TMyWindow.cmGroup(VAR MSG: TMessage);
BEGIN
  World.GroupSelected(Colr[CurrentColor], Colr[CurrentFillColor]);
  cmSetMenu(MSG);
END;

Procedure TMyWindow.cmUngroup(VAR MSG: TMessage);
BEGIN
  World.UngroupSelected;
  cmSetMenu(MSG);
END;

Procedure TMyWindow.cmConnect(VAR MSG: TMessage);
BEGIN
  World.ConnectSelected(Colr[CurrentColor], Colr[CurrentFillColor]);
  cmSetMenu(MSG);
END;

Procedure TMyWindow.SetSelPos(Pos: Word);
BEGIN
  if not ToolsActive then
  begin
    ToolsActive := True;
    ToolsBusy := True; 
    World.ShowFrame;
    World.SetSelectedPosition(Pos);
    World.ShowFrame;
    SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);
    ToolsActive := False;
  end;
END;

Procedure TMyWindow.cmBack(VAR MSG: TMessage);
BEGIN
  SetSelPos(0);
END;

Procedure TMyWindow.cmFront(VAR MSG: TMessage);
BEGIN
  SetSelPos(1);
END;

Procedure TMyWindow.cmOneBack(VAR MSG: TMessage);
BEGIN
  SetSelPos(2);
END;

Procedure TMyWindow.cmOneForward(VAR MSG: TMessage);
BEGIN
  SetSelPos(3);
END;

Procedure TMyWindow.cmShowMenu(VAR MSG: TMessage);
BEGIN
  if TWActive then
    Dispose(ToolWindow, Done)
  else
  begin
    ToolWindow := New(PToolWindow, Init(@Self));
    ToolWindow^.Create;
    MoveWindow(ToolWindow^.HWindow, Attr.X+3, Attr.Y+72, 31, 20+TWSize*15, True);
    OldTW1 := TW1;
  end;
  cmSetMenu(MSG);
END;

Procedure TMyWindow.cmShowPal(VAR MSG: TMessage);
BEGIN
  if TPActive then
    Dispose(PaletteWindow, Done)
  else
  begin
    PaletteWindow := New(PPaletteWindow, Init(@Self, ShowColor));
    PaletteWindow^.Create;
    MoveWindow(PaletteWindow^.HWindow, Attr.X+Attr.W-4*15-20-17, Attr.Y+72, 4*15+17, 20+5*15, True);
    OldTP1 := TP1;
  end;
  cmSetMenu(MSG);
END;

Procedure TMyWindow.cmScriptRecord(VAR MSG: TMessage);
 var
    X1, Y1, X2, Y2: Real;
begin
  if not ScriptPlay then
    ScriptRecord := not ScriptRecord;
  if ScriptRecord and (World.Count>0) then
  begin
    World.Script.ClearScript;
    World.CalcFrame;
    World.GetFirstSelectedLinePoints(X1, Y1, X2, Y2);
    World.Script.StartRecord(X1, Y1, X2, Y2);
  end
  else
    ScriptRecord := False;
  cmSetMenu(MSG);
  if ScriptRecord then
    StateLine^.SetAddText('   Makroaufzeichnung')
  else
    StateLine^.SetAddText('');
end;

Procedure TMyWindow.cmScriptPlay(VAR MSG: TMessage);
 var
    X1, Y1, X2, Y2: Real;
begin
  if (not ToolsActive) and not ScriptPlay and (World.Count>0) then
  begin
    ToolsActive := True;
    ToolsBusy := True;
    if ScriptRecord then
      cmScriptRecord(MSG);
    ScriptPlay := True;
    cmSetMenu(MSG);
    World.GetFirstSelectedLinePoints(X1, Y1, X2, Y2);
    World.Script.SetPos(X1, Y1, X2, Y2);
    World.ShowFrame;
    World.Replay;
    World.ShowFrame;
    SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);
    ScriptPlay := False;
    ToolsActive := False;
    cmSetMenu(MSG);
  end;
end;
 
Procedure TMyWindow.cmScriptIterate(VAR MSG: TMessage);
 var
    Buffer: TIterateInfo;
    SX1, SY1, SX2, SY2: Real;
BEGIN
  if (not ToolsActive) and not ScriptPlay and (World.Count>0) then
  BEGIN
    ToolsActive := True;
    ToolsBusy := True;
    if ScriptRecord then
      cmScriptRecord(MSG);
    ScriptPlay := True;
    cmSetMenu(MSG);
    SendMessage(Drawing^.HWindow, WM_Command, cm_SaveBitmap, 0);
    Buffer.Anz := 3;
    Buffer.SelfIterate := False;
    if Application^.ExecDialog(new(PIterateDialog, Init(nil, @Buffer)))= id_ok then
    begin
      if (Buffer.Anz<1) then
        MessageBox(HWindow, 'Ungltige Anzahl Zwischenschritte!', 'Makro Iterieren', mb_OK + mb_IconStop)
      else
      begin
{        DisableWindowTime;}
        BitBlt(vhDC, 0, 0, xw, yw, BufferDC, 0,0, SrcCopy);
        World.ShowFrame;
        World.GetFrame(SX1, SY1, SX2, SY2);
        World.Iterate(Buffer.Anz, Buffer.SelfIterate);
        World.ShowFrame;
        SendMessage(Drawing^.HWindow, WM_Command, cm_SaveBitmap, 0);
{        EnableWindowTime;}
      end;
    end;
    ScriptPlay := False;
    ToolsActive := False;
    cmSetMenu(MSG);

    ToolsActive := False;
  END;
END;


Procedure TMyWindow.cmScriptClear(VAR MSG: TMessage);
begin
  if not ScriptPlay then
  begin
    if ScriptRecord then
      cmScriptRecord(MSG);
    World.Script.ClearScript;
  end;
  cmSetMenu(MSG);
end;

Procedure TMyWindow.cmBlend(VAR MSG: TMessage);
 var
    Buffer: TBlendInfo;
    SX1, SY1, SX2, SY2: Real;
BEGIN
  IF not ToolsActive THEN
  BEGIN
    ToolsActive := True;
    ToolsBusy := True;
    SendMessage(Drawing^.HWindow, WM_Command, cm_SaveBitmap, 0);
    Buffer.Steps := 5;
    if Application^.ExecDialog(new(PBlendDialog, Init(nil, @Buffer)))= id_ok then
    begin
      if (Buffer.Steps<1) then
        MessageBox(HWindow, 'Ungltige Anzahl Zwischenschritte!', 'berblenden', mb_OK + mb_IconStop)
      else
      begin
        DisableWindowTime;
        BitBlt(vhDC, 0, 0, xw, yw, BufferDC, 0,0, SrcCopy);
        World.ShowFrame;
        World.GetFrame(SX1, SY1, SX2, SY2);
        World.Blend(Buffer.Steps);
        World.RedrawSelected(SX1, SY1, SX2, SY2);
        World.ShowFrame;
        SendMessage(Drawing^.HWindow, WM_Command, cm_SaveBitmap, 0);
        EnableWindowTime;
      end;
    end;
    cmSetMenu(MSG);

    ToolsActive := False;
  END;
END;

Procedure TMyWindow.cmBreak(VAR MSG: TMessage);
BEGIN
  IF Running or ToolsActive THEN
  BEGIN
    BreakFlag := True;
    BreakMain;
  END;
END;


Procedure TMyWindow.cmShowProgress(VAR MSG: TMessage);
BEGIN
  if CheckMenuItem(Attr.Menu, cm_ShowProgress, mf_ByCommand) then
  begin
      CheckMenuItem(Attr.Menu, cm_ShowProgress, mf_UnChecked or mf_ByCommand);
      HideProgress;
  end
  else
  begin
      CheckMenuItem(Attr.Menu, cm_ShowProgress, mf_Checked or mf_ByCommand);
      ShowProgress;
  end;
END;


Procedure TMyWindow.cmSkipCut(VAR MSG: TMessage);
BEGIN
  IF Running THEN
  BEGIN
    Skip(1);
  END;
END;

Procedure TMyWindow.cmSkipLine(VAR MSG: TMessage);
BEGIN
  IF Running THEN
  BEGIN
    Skip(2);
  END;
END;

Procedure TMyWindow.cmSkipAll(VAR MSG: TMessage);
BEGIN
  IF Running THEN
  BEGIN
    Skip(3);
  END;
END;


{----------------------------------------------}

Procedure TMyWindow.cmConv(VAR MSG: TMessage);
 VAR
    ScrWidth, ScrHeight : Integer;
BEGIN
  IF Running or ToolsActive THEN
  BEGIN
    BreakFlag := True;
    BreakMain;
    PostMessage(HWindow,wm_command, cm_Conv, 0);
    Exit;
  END;

  Converted := False;
  BreakFlag := False;
  Running := True;

  World.ShowFrame;
  World.ClearSelected;
  CMSetMenu(MSG);
  CheckMenuItem(Attr.Menu, cm_Conv, mf_Checked or mf_ByCommand);

  main;

  SendMessage(Drawing^.HWindow, wm_Command, cm_SaveBitmap, 0);

  WMTimer(MSG);

  if not BreakFlag then
    Converted := True;

  Running := False;
  CMSetMenu(MSG);
  CheckMenuItem(Attr.Menu, cm_Conv, mf_UnChecked or mf_ByCommand);
END;

function WToS(w: LongInt): String;
 var
    s: String;
begin
    str(w,s);
    WToS := s;
end; 


type
    PMinMaxInfo = ^MinMaxInfoType;
    MinMaxInfoType = array[0..4] of TPoint;

{
procedure TMyWindow.WMGetMinMaxInfo(var Msg: TMessage);
 var
    MinMaxInfoPtr: PMinMaxInfo;
begin
  MinMaxInfoPtr := PMinMaxInfo(Msg.LParam);
  MinMaxInfoPtr^[1].X := 2+xw+17;
  MinMaxInfoPtr^[1].Y := 40+yw+20+32+20+17;
end;
}

procedure TMyWindow.WMSize(var Msg: TMessage);
begin
  xw := Integer(Msg.LParamLo-17);
  yw := Integer(Msg.LParamHi-89);
  TWindow.WMSize(Msg);
  if Msg.WParam = Size_Maximized then
  begin
    if TWActive then
      MoveWindow(ToolWindow^.HWindow, -1, 68, 31, 20+TWSize*15, True);
    if TPActive then
      MoveWindow(PaletteWindow^.HWindow, xw-4*15-17+1, 68, 4*15+17, 20+5*15, True);
  end
  else
  begin
    if TWActive then
      MoveWindow(ToolWindow^.HWindow, Attr.X+3, Attr.Y+72, 31, 20+TWSize*15, True);
    if TPActive then
      MoveWindow(PaletteWindow^.HWindow, Attr.X+Attr.W-4*15-17-20, Attr.Y+72, 4*15+17, 20+5*15, True);
  end;
  UpdateChildren;
end;

procedure TMyWindow.WMMove(var Msg: TMessage);
 var
    x, y: Integer;
begin
  x := Attr.X;
  y := Attr.Y;
  TWindow.WMMove(Msg);
  x := Attr.X-x;
  y := Attr.Y-y;
  if TWActive then
    MoveWindow(ToolWindow^.HWindow, ToolWindow^.Attr.X+x,
                                    ToolWindow^.Attr.Y+y, 31, 20+TWSize*15, True);
  if TPActive then
    MoveWindow(PaletteWindow^.HWindow, PaletteWindow^.Attr.X+x,
                                       PaletteWindow^.Attr.Y+y,
                                       4*15+17, 20+5*15, True);
end;

procedure TMyWindow.WMTimer(var Msg: TMessage);
 var
    r: TRect;
    s: String;
    a: array[0..79] of char;
    OldMode: Integer;
    OldColor:LongInt;
    i: Integer;
    State: array[0..2] of LongInt;
    MainDC: HDC;
BEGIN
  MainDC := GetDC(HWindow);
  SetRect(r, 0, yw+52+17, xw+17, yw+72+17);
  FillRect(MainDC, r, GetStockObject (LTGRAY_BRUSH));
  MoveTo(MainDC,0,yw+51+17);
  LineTo(MainDC,xw+17,yw+51+17);

  if Running or ToolsActive then
  begin

    for i := 0 to 2 do
      State[i] := GetState(i);

    s := '';
    Case State[0] of
     -2 : s := 'Bild konvertiert.';
     -1 : s := 'Bild geladen.';
      0 : s := 'Initialisierung.';
      1 : s := 'Schnitte: '+WToS(State[1])+'/'+WToS(State[2]);
      2 : s := 'Graph: '+WToS(State[1])+'/'+WToS(State[2]);
      3 : s := 'Flchen: '+WToS(State[1])+'/'+WToS(State[2]);
      4 : s := 'Malen: '+WToS(State[1])+'/'+WToS(State[2]);
      5 : s := 'Lese <'+InFileName+'>: '+WToS(State[1] div 1024)+'k/'+WToS(State[2] div 1024)+'k';
      6 : s := 'Gruppierungen auflsen: '+WToS(State[1])+'/'+WToS(State[2]);
    end;
    StrPCopy(a,s);

    OldMode := SetBkMode(MainDC, Transparent);
    OldColor := SetTextColor(MainDC, rgb(128,0,0));
    TextOut(MainDC, 2,yw+55+17, a,length(s));
    SetBkMode(MainDC, OldMode);
    SetTextColor(MainDC,OldColor);

    if (State[0]>=1) and (State[0]<=6) then
    begin
      if State[2]>0 then
      begin
        State[1] := State[1]+1;
        if State[1]>State[2] then
          State[1] := State[2];    
        SetRect(r, 2, yw+54+17, 3+trunc((xw-5+17)*State[1]/State[2]), yw+71+17);
        InvertRect(MainDC, r);
      end;
    end;
  end;
  ReleaseDC(HWindow, MainDC);
END;


procedure TMyWindow.WMChar(var Msg: TMessage);
 var
    X1, Y1, X2, Y2: Real;
    GroupPtr: PGroup;
begin
  SendMessage(ToolBar^.HWindow, WM_Command, cm_MyWindowChar, Msg.WParam * 65536);
  DefWndProc(Msg);
end;


Function TMyWindow.CanClose: Boolean;
 var
    TempFile: Text;
    i: Integer;
BEGIN
  CanClose := (Not Running) and (not ToolsActive);
  BreakFlag := True;
  IF Running or ToolsActive then
  begin
    BreakMain;
    PostMessage(HWindow, wm_Close, 0, 0)
  end
  else
  begin

    KillTimer(HWindow, 0);

    if TWActive then
      Dispose(ToolWindow, Done);
    if TPActive then
      Dispose(PaletteWindow, Done);
    Dispose(ToolBar, Done);
    Dispose(Drawing, Done);
    Dispose(ShowColor, Done);
    Dispose(StateLine, Done);
    Font.Done;

  end;

  assign(TempFile, CDRDIR+'PASNEW.IA');
  {$I-}
  reset(TempFile);
  {$I+}
  if IOResult=0 then
  begin
    close(TempFile);
    erase(TempFile);
  end;

  SaveConfig;

END;

Procedure TMyApplication.InitMainWindow;
BEGIN
  MainWindow := New(PMyWindow, Init(NIL, 'Adobe Illustrator -> CorelDraw'));
  HAccTable := LoadAccelerators(HInstance, 'ACCELERATORS_1');
END;

 VAR
    MeinProgramm : TMyApplication;

BEGIN
  MeinProgramm.Init('');
  MeinProgramm.Run;
  MeinProgramm.Done;
END.



