unit Dialogs;

interface

uses {WObjects}Objects, WinTypes, WinProcs, Strings, Defs, ODialogs, OWindows;

type

  PIterateDialog = ^TIterateDialog;
  TIterateDialog = Object(TDialog)
    Buffer: PIterateInfo;
    constructor Init(AParent: PWindowsObject; ABuffer: PIterateInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;

  PBlendDialog = ^TBlendDialog;
  TBlendDialog = Object(TDialog)
    Buffer: PBlendInfo;
    constructor Init(AParent: PWindowsObject; ABuffer: PBlendInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;

  PRotateDialog = ^TRotateDialog;
  TRotateDialog = Object(TDialog)
    Buffer: PRotateInfo;
    constructor Init(AParent: PWindowsObject; ABuffer: PRotateInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;

  PSizeDialog = ^TSizeDialog;
  TSizeDialog = Object(TDialog)
    Buffer: PSizeInfo;
    constructor Init(AParent: PWindowsObject; ABuffer: PSizeInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;

  PGridDialog = ^TGridDialog;
  TGridDialog = Object(TDialog)
    Buffer: PGridInfo;
    constructor Init(AParent: PWindowsObject; ABuffer: PGridInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;

  PMoveDialog = ^TMoveDialog;
  TMoveDialog = Object(TDialog)
    Buffer: PMoveInfo;
    constructor Init(AParent: PWindowsObject; ABuffer: PMoveInfo);
    procedure SetupWindow; virtual;
    procedure Ok(var Msg: TMessage); virtual id_First + id_OK;
  end;


function ChooseColorDialog(AWindow: HWnd; var ColorRef: LongInt): Boolean;
function NewFileDialog(Owner: HWnd;var Filename: String; Save: Boolean): Boolean;
function FontDialog(AWnd: HWnd; var ALogFont: TLogFont): Boolean;

implementation

uses commdlg;



{----------- TITERATEDIALOG ----------------}

constructor TIterateDialog.Init(AParent: PWindowsObject; ABuffer: PIterateInfo);
begin
  Buffer := ABuffer;
  TDialog.Init(AParent, 'IterateDialog');
end;

procedure TIterateDialog.SetupWindow;
 var
    a: array[0..80] of char;
    s: String;
begin
  TDialog.SetupWindow;
  str(Buffer^.Anz:4,s);
  strpcopy(a,s);
  SendDlgItemMsg(101, wm_SetText, length(s), longint(@a));
  if Buffer^.SelfIterate then
    SendDlgItemMsg(201, bm_SetCheck, 1, 0)
  else
    SendDlgItemMsg(201, bm_SetCheck, 0, 0);
end;

procedure TIterateDialog.Ok(var Msg: TMessage);
 var
    a: array[0..80] of char;
    VCode: Word;
begin
  SendDlgItemMsg(101, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.Anz, VCode);
  Buffer^.SelfIterate := SendDlgItemMsg(201, bm_GetCheck, 0, 0)<>0;
  TDialog.OK(Msg);
end;



{----------- TBLENDDIALOG ----------------}

constructor TBlendDialog.Init(AParent: PWindowsObject; ABuffer: PBlendInfo);
begin
  Buffer := ABuffer;
  TDialog.Init(AParent, 'BlendDialog');
end;

procedure TBlendDialog.SetupWindow;
 var
    a: array[0..80] of char;
    s: String;
begin
  TDialog.SetupWindow;
  str(Buffer^.Steps:4,s);
  strpcopy(a,s);
  SendDlgItemMsg(101, wm_SetText, length(s), longint(@a));
end;

procedure TBlendDialog.Ok(var Msg: TMessage);
 var
    a: array[0..80] of char;
    VCode: Word;
begin
  SendDlgItemMsg(101, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.Steps, VCode);
  TDialog.OK(Msg);
end;



{----------- TROTATEDIALOG ----------------}

constructor TRotateDialog.Init(AParent: PWindowsObject; ABuffer: PRotateInfo);
begin
  Buffer := ABuffer;
  TDialog.Init(AParent, 'RotateDialog');
end;

procedure TRotateDialog.SetupWindow;
 var
    a: array[0..80] of char;
    s: String;
begin
  TDialog.SetupWindow;
  str(Buffer^.Alpha:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(101, wm_SetText, length(s), longint(@a));
end;

procedure TRotateDialog.Ok(var Msg: TMessage); 
 var
    a: array[0..80] of char;
    VCode: Word;
begin
  SendDlgItemMsg(101, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.Alpha, VCode);
  TDialog.OK(Msg);
end;


{----------- TSIZEDIALOG ----------------}

constructor TSizeDialog.Init(AParent: PWindowsObject; ABuffer: PSizeInfo);
begin
  Buffer := ABuffer;
  TDialog.Init(AParent, 'SizeDialog');
end;

procedure TSizeDialog.SetupWindow; 
 var
    a: array[0..80] of char;
    s: String;
begin
  TDialog.SetupWindow;
  str(Buffer^.X1:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(101, wm_SetText, length(s), longint(@a));
  str(Buffer^.Y1:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(102, wm_SetText, length(s), longint(@a));
  str(Buffer^.X2:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(103, wm_SetText, length(s), longint(@a));
  str(Buffer^.Y2:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(104, wm_SetText, length(s), longint(@a));
end;

procedure TSizeDialog.Ok(var Msg: TMessage); 
 var
    a: array[0..80] of char;
    VCode: Word;
begin
  SendDlgItemMsg(101, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.X1, VCode);
  SendDlgItemMsg(102, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.Y1, VCode);
  SendDlgItemMsg(103, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.X2, VCode);
  SendDlgItemMsg(104, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.Y2, VCode);
  TDialog.OK(Msg);
end;


{----------- TGRIDDIALOG ----------------}


constructor TGridDialog.Init(AParent: PWindowsObject; ABuffer: PGridInfo);
begin
  Buffer := ABuffer;
  TDialog.Init(AParent, 'GridDialog');
end;

procedure TGridDialog.SetupWindow; 
 var
    a: array[0..80] of char;
    s: String;
begin
  TDialog.SetupWindow;

  str(Buffer^.GridX:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(101, wm_SetText, length(s), longint(@a));

  str(Buffer^.GridY:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(102, wm_SetText, length(s), longint(@a));

  if Buffer^.SnapX then
    SendDlgItemMsg(201, bm_SetCheck, 1, 0)
  else
    SendDlgItemMsg(201, bm_SetCheck, 0, 0);

  if Buffer^.SnapY then
    SendDlgItemMsg(202, bm_SetCheck, 1, 0)
  else
    SendDlgItemMsg(202, bm_SetCheck, 0, 0);

  if Buffer^.Show then
    SendDlgItemMsg(203, bm_SetCheck, 1, 0)
  else
    SendDlgItemMsg(203, bm_SetCheck, 0, 0);

end;

procedure TGridDialog.Ok(var Msg: TMessage); 
 var
    a: array[0..80] of char;
    VCode: Word;
begin
  SendDlgItemMsg(101, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.GridX, VCode);
  if Buffer^.GridX<=0 then
  begin
    MessageBox(HWindow, 'Das X-Raster ist ungltig', 'Raster einrichten', mb_ok+mb_iconExclamation);
    Buffer^.GridX := 1;
  end;

  SendDlgItemMsg(102, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.GridY, VCode);
  if Buffer^.GridY<=0 then
  begin
    MessageBox(HWindow, 'Das Y-Raster ist ungltig', 'Raster einrichten', mb_ok+mb_iconExclamation);
    Buffer^.GridY := 1;
  end;

  Buffer^.SnapX := SendDlgItemMsg(201, bm_GetCheck, 0, 0)<>0;
  Buffer^.SnapY := SendDlgItemMsg(202, bm_GetCheck, 0, 0)<>0;
  Buffer^.Show  := SendDlgItemMsg(203, bm_GetCheck, 0, 0)<>0;

  TDialog.OK(Msg);
end;

{----------- TMOVEDIALOG ----------------}

constructor TMoveDialog.Init(AParent: PWindowsObject; ABuffer: PMoveInfo);
begin
  Buffer := ABuffer;
  TDialog.Init(AParent, 'MoveDialog');
end;

procedure TMoveDialog.SetupWindow; 
 var
    a: array[0..80] of char;
    s: String;
begin
  TDialog.SetupWindow;
  str(Buffer^.X1:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(101, wm_SetText, length(s), longint(@a));
  str(Buffer^.Y1:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(102, wm_SetText, length(s), longint(@a));
  str(Buffer^.X2:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(103, wm_SetText, length(s), longint(@a));
  str(Buffer^.Y2:7:3,s);
  strpcopy(a,s);
  SendDlgItemMsg(104, wm_SetText, length(s), longint(@a));
end;

procedure TMoveDialog.Ok(var Msg: TMessage); 
 var
    a: array[0..80] of char;
    VCode: Word;
begin
  SendDlgItemMsg(101, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.X1, VCode);
  SendDlgItemMsg(102, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.Y1, VCode);
  SendDlgItemMsg(103, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.X2, VCode);
  SendDlgItemMsg(104, wm_gettext, 80, Longint(@a));
  val(a, Buffer^.Y2, VCode);
  TDialog.OK(Msg);
end;

{----- Win31 Dialoge ------}

function ChooseColorDialog(AWindow: HWnd; var ColorRef: LongInt): Boolean;
type
  TLongAry = array [0..15] of Longint;
const
  { Establishes a set of custom colors in 15 shades of blue }
  CustColors: TLongAry = (
    $000000, $100000, $200000, $300000,
    $400000, $500000, $600000, $700000,
    $800000, $900000, $A00000, $B00000,
    $C00000, $D00000, $E00000, $F00000);
var
  ChooseClr: TChooseColor;
  i        : Integer;
begin
  ChooseColorDialog := False;
  with ChooseClr do
  begin
    HWndOwner   := AWindow;
    lStructSize := Sizeof(TChooseColor);
    rgbResult   := ColorRef;
    lpCustColors:= @CustColors;
    Flags       := cc_FullOpen or cc_RGBInit;
      {Allow custom colors and the initialization through rgbResult}
  end;
  if not ChooseColor(ChooseClr) then
    Exit;
  ColorRef := ChooseClr.RGBResult;
  ChooseColorDialog := True;
end;

function NewFileDialog(Owner: HWnd;var Filename: String; Save: Boolean): Boolean;
const
  DefOpenFilename: TOpenFilename = (
    lStructSize: SizeOf(TOpenFilename);
    hwndOwner: 0;
    hInstance: 0;
    lpstrFilter: 'Adobe Dateien (*.AI)'#0'*.ai'#0;
    lpstrCustomFilter: nil;
    nMaxCustFilter: 0;
    nFilterIndex: 0;
    lpstrFile: nil;
    nMaxFile: SizeOf(TFilename);
    lpstrFileTitle: nil;
    nMaxFileTitle: 0;
    lpstrInitialDir: nil;
    lpstrTitle: nil;
    Flags: 0;
    nFileOffset: 0;
    nFileExtension: 0;
    lpstrDefExt: 'ai');
var
  OpenFilename: TOpenFilename;
  FNPath, FNName: TFilename;
  i: Integer;
begin
  OpenFilename := DefOpenFilename;
  OpenFilename.hwndOwner := Owner;

  i := length(FileName);
  while (i>0) and (FileName[i]<>'\') do
    i := i-1;
  StrPCopy(FNPath, copy(FileName,1, i-1));
  StrPCopy(FNName, copy(FileName,i+1,length(FileName)));

  OpenFileName.lpstrInitialDir := @FNPath;
  OpenFilename.lpstrFile := @FNName;

  if Save then
  begin
    OpenFilename.Flags := ofn_PathMustExist + ofn_NoChangeDir +
      ofn_OverwritePrompt;
    NewFileDialog := GetSaveFilename(OpenFilename);
  end else
  begin
    OpenFileName.Flags := ofn_PathMustExist + ofn_HideReadOnly;
    NewFileDialog := GetOpenFilename(OpenFilename);
  end;
  FileName := StrPas(OpenFileName.lpstrFile);
end;


function FontDialog(AWnd: HWnd; var ALogFont: TLogFont): Boolean;
var
  ChooseRec: TChooseFont;
  Colors   : LongInt;
  Style    : array [0..100] of Char;
  TempFont : TLogFont;
begin
  FontDialog := False;
  TempFont := ALogFont;
  FillChar(ChooseRec, SizeOf(ChooseRec), #0);
  with ChooseRec do
  begin
    lStructSize:= SizeOf(TChooseFont);
    hwndOwner  := AWnd;
    lpLogFont  := @TempFont;
    Flags      := cf_TTOnly or cf_ScreenFonts or cf_Effects or cf_InitToLogFontStruct;
    rgbColors  := rgb(0,0,0);
    lpszStyle  := Style;
  end;
  if not ChooseFont(ChooseRec) then
    Exit;

  ALogFont := TempFont;
  FontDialog := True;
end;

end.
