unit Status;

interface

uses {WObjects}Objects, WinTypes, WinProcs, Strings, OWindows;

type
  PStateLine = ^TStateLine;
  TStateLine = object(TWindow)
    S, SAdd: String;

    { Creation and destruction }
    constructor Init(AParent: PWindowsObject);

    { Utility }
    procedure SetText(S2: String); virtual;
    procedure SetAddText(S2: String); virtual;

    { Display } 
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;

  end;

  PShowColor = ^TShowColor;
  TShowColor = object(TWindow)
    constructor Init(AParent: PWindowsObject);
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
  end;

implementation

uses Defs;

{-------- TSTATELINE -----------}

constructor TStateLine.Init(AParent: PWindowsObject);
begin
  TWindow.Init(AParent, nil);
  Attr.Style := ws_Child or ws_Visible;
  S := 'Initialisierung';
  SAdd := '';
end;

procedure TStateLine.SetText(S2: String);
 var
    DC: HDC;
    PI: TPaintStruct;
begin
  S := S2;
  DC := GetDC(HWindow);
  Paint(DC, PI);
  ReleaseDC(HWindow, DC);
end;

procedure TStateLine.SetAddText(S2: String);
 var
    DC: HDC;
    PI: TPaintStruct;
begin
  SAdd := S2;
  DC := GetDC(HWindow);
  Paint(DC, PI);
  ReleaseDC(HWindow, DC);
end;


procedure TStateLine.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  R: TRect;
  a: array[0..255] of char;
  OldMode: Integer;
  OldColor: LongInt;	
begin
  StrPCopy(a,S+SAdd);

  SetRect(r, 0, 1, xw+17, 20);
  FillRect(PaintDC, r, GetStockObject (LTGRAY_BRUSH));
  MoveTo(PaintDC,   0, 0);
  LineTo(PaintDC, xw+17, 0);
  OldMode := SetBkMode(PaintDC, Transparent);
  OldColor := SetTextColor(PaintDC, rgb(0,0,0));
  TextOut(PaintDC, 2,3, a,length(S+SAdd));
  SetBkMode(PaintDC, OldMode);
  SetTextColor(paintDC,OldColor);
end;


{-------- TSHOWCOLOR -----------}

constructor TShowColor.Init(AParent: PWindowsObject);
begin
  TWindow.Init(AParent, nil);
  Attr.Style := ws_Child or ws_Visible;
end;

procedure TShowColor.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);
var
  R: TRect;
  Br: HBrush;
begin
  SetRect(r, 0, 0, 20, 20);
  FillRect(PaintDC, r, GetStockObject(WHITE_BRUSH));
  FrameRect(PaintDC, r, GetStockObject(BLACK_BRUSH));
  SetRect(r, 3, 3, 17, 17);
  if Colr[CurrentFillColor]<>-1 then
  begin
    Br := CreateSolidBrush(Colr[CurrentFillColor]);
    FillRect(PaintDC, r, Br);
    DeleteObject(Br);
  end;
  if Colr[CurrentColor]<>-1 then
  begin 
    Br := CreateSolidBrush(Colr[CurrentColor]);
    FrameRect(PaintDC, r, Br);
    DeleteObject(Br);
  end;
end;



end.